diff --git a/src/Fl_Help_View.cxx b/src/Fl_Help_View.cxx
index 4ae4f29..aae20dc 100644
--- a/src/Fl_Help_View.cxx
+++ b/src/Fl_Help_View.cxx
@@ -58,6 +58,7 @@
 #include <ctype.h>
 #include <errno.h>
 #include <math.h>
+#include <stack>
 
 #if defined(WIN32) && ! defined(__CYGWIN__)
 #  include <io.h>
@@ -446,6 +447,9 @@ Fl_Help_View::draw()
 					// Box to draw...
   int			underline,	// Underline text?
                         xtra_ww;        // Extra width for underlined space between words
+  std::stack<int>       OL_num;         // if nonnegative, in OL mode and this is the item number
+
+  OL_num.push(-1);
 
   // Draw the scrollbar(s) and box first...
   ww = w();
@@ -700,15 +704,30 @@ Fl_Help_View::draw()
 	      pre   = 1;
 	    }
 
+	    if (strcasecmp(buf, "OL") == 0)
+	      OL_num.push(1);
+	    else if (strcasecmp(buf, "UL") == 0)	// "UL", not "/UL"
+	      OL_num.push(-1);
+	    else if (strcasecmp(buf, "/OL") == 0 ||
+		     strcasecmp(buf, "/UL") == 0)
+	      OL_num.pop();
+
             if (strcasecmp(buf, "LI") == 0)
 	    {
 //            fl_font(FL_SYMBOL, fsize); // The default SYMBOL font on my XP box is not Unicode...
-              char buf[8];
-              wchar_t b[] = {0x2022, 0x0};
-//            buf[fl_unicode2utf(b, 1, buf)] = 0;
-              unsigned dstlen = fl_utf8fromwc(buf, 8, b, 1);
-              buf[dstlen] = 0;
-              hv_draw(buf, xx - fsize + x() - leftline_, yy + y());
+	      char buf[8];
+	      if (OL_num.top()<0) {
+		wchar_t b[] = {0x2022, 0x0};    // this is a bullet symbol
+//		buf[fl_unicode2utf(b, 1, buf)] = 0;
+		unsigned dstlen = fl_utf8fromwc(buf, 8, b, 1);
+		buf[dstlen] = 0;
+	      } else {
+		sprintf(buf, "%d. ", OL_num.top());
+		int nnum = OL_num.top()+1;
+		OL_num.pop();
+		OL_num.push(nnum);
+	      }
+	      hv_draw(buf, xx - fsize + x() - leftline_, yy + y());
 	    }
 
 	    pushfont(font, fsize);
